VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   2160
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4110
   LinkTopic       =   "Form1"
   ScaleHeight     =   2160
   ScaleWidth      =   4110
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command3 
      Caption         =   "Version 3"
      Height          =   495
      Left            =   120
      TabIndex        =   2
      Top             =   1560
      Width           =   1215
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Version 2"
      Height          =   495
      Left            =   120
      TabIndex        =   1
      Top             =   840
      Width           =   1215
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Version 1"
      Height          =   495
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1215
   End
   Begin VB.Label lblTime3 
      Height          =   255
      Left            =   1560
      TabIndex        =   5
      Top             =   1680
      Width           =   2415
   End
   Begin VB.Label lblTime2 
      Height          =   255
      Left            =   1560
      TabIndex        =   4
      Top             =   960
      Width           =   2415
   End
   Begin VB.Label lblTime1 
      Height          =   255
      Left            =   1560
      TabIndex        =   3
      Top             =   240
      Width           =   2415
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Function CompressSpaces(ByVal txt As String) As String
    Do While InStr(txt, "  ") > 0
        txt = Replace(txt, "  ", " ")
    Loop
    CompressSpaces = txt
End Function

Private Sub Command1_Click()
Const NUM_TRIALS = 500
Dim trial As Long
Dim start_time As Single
Dim stop_time As Single
Dim i As Integer
Dim txt As String
Dim trim_txt As String

    Screen.MousePointer = vbHourglass
    DoEvents

    For i = 0 To 25
        txt = txt & Chr$(Asc("A") + i) & Space$(i)
    Next i
    For i = 1 To 4
        txt = txt & txt
    Next i

    start_time = Timer
    For trial = 1 To NUM_TRIALS
        txt = PreventDuplicateSpaces(txt)
    Next trial
    stop_time = Timer

    lblTime1.Caption = Format$((stop_time - start_time) / NUM_TRIALS, "0.000000") & " seconds per run"
    Screen.MousePointer = vbDefault
End Sub

' Replaces sequential spaces with single spaces.
' Spaces on either end are removed.
Private Function PreventDuplicateSpaces(ByVal Word)
    Dim i, WordLength, Character, LastCharacter, NewWord

    On Error GoTo ErrorHandler
    WordLength = Len(Word)
    For i = 1 To WordLength
        Character = Mid(Word, i, 1)
        If LastCharacter = " " And Character = " " Then
        Else
            NewWord = NewWord & Character
            LastCharacter = Character
        End If
    Next i

    PreventDuplicateSpaces = Trim(NewWord)
    Exit Function

ErrorHandler:
    ' Insert your favorite error handler here.
End Function
    
Private Sub Command2_Click()
Const NUM_TRIALS = 20000
Dim trial As Long
Dim start_time As Single
Dim stop_time As Single
Dim i As Integer
Dim txt As String
Dim trim_txt As String

    Screen.MousePointer = vbHourglass
    DoEvents

    For i = 0 To 25
        txt = txt & Chr$(Asc("A") + i) & Space$(i)
    Next i
    For i = 1 To 4
        txt = txt & txt
    Next i

    start_time = Timer
    For trial = 1 To NUM_TRIALS
        txt = fastremoveduplicatespaces(txt)
    Next trial
    stop_time = Timer

    lblTime2.Caption = Format$((stop_time - start_time) / NUM_TRIALS, "0.000000") & " seconds per run"
    Screen.MousePointer = vbDefault
End Sub
Private Sub Command3_Click()
Const NUM_TRIALS = 20000
Dim trial As Long
Dim start_time As Single
Dim stop_time As Single
Dim i As Integer
Dim txt As String
Dim trim_txt As String

    Screen.MousePointer = vbHourglass
    DoEvents

    For i = 0 To 25
        txt = txt & Chr$(Asc("A") + i) & Space$(i)
    Next i
    For i = 1 To 4
        txt = txt & txt
    Next i

    start_time = Timer
    For trial = 1 To NUM_TRIALS
        txt = CompressSpaces(txt)
    Next trial
    stop_time = Timer

    lblTime3.Caption = Format$((stop_time - start_time) / NUM_TRIALS, "0.000000") & " seconds per run"
    Screen.MousePointer = vbDefault
End Sub
Function fastremoveduplicatespaces$(ByVal txt$)
Dim localtxt$, pt%

  localtxt$ = Trim$(txt$)
  Do
    pt% = InStr(localtxt$, "  ")  ' 2 blank spaces
    If pt% = 0 Then Exit Do
    localtxt$ = Left$(localtxt$, pt%) + Trim$(Mid$(localtxt$, pt%))
  Loop
  fastremoveduplicatespaces$ = localtxt$
End Function

